import java.applet.*;
import java.awt.*;
import java.awt.event.*;

/**
 * Main class for the tree applet.
 * @author Till Krullmann
 * @version 1.0
 */
public class TreeApplet extends Applet implements ActionListener, ComponentListener
{
	/** <b>BinaryTreeCanvas</b> object used to draw the actual tree. */
	BinaryTreeCanvas treeCanvas;
	
	/** <b>UserPanel</b> object to hold user input controls */
	Panel userPanel;
	static final int USERPANEL_WIDTH = 400;
	static final int USERPANEL_HEIGHT = 40;
	
	Choice choiceOperation;
	TextField textValue;
	
	public void actionPerformed(ActionEvent e)
	{
		if (e.getID() == ActionEvent.ACTION_PERFORMED)
		{
			try
			{
				Integer value = new Integer(textValue.getText());
				
				switch(choiceOperation.getSelectedIndex())
				{
					case 0: treeCanvas.insert(value); break;
					case 1: treeCanvas.remove(value); break;
				}
			}
			catch (NumberFormatException ex)
			{
				this.showStatus("NumberFormatException: " + ex.getMessage());
			}	
			
			textValue.setText("");
		}
	}
	
	public void componentHidden(ComponentEvent e) { }
	public void componentMoved(ComponentEvent e) { }
	public void componentShown(ComponentEvent e) { }
	
	public void componentResized(ComponentEvent e)
	{
		userPanel.setBounds(0, 0, getWidth(), USERPANEL_HEIGHT);
		treeCanvas.setBounds(0, USERPANEL_HEIGHT, getWidth(), getHeight() - USERPANEL_HEIGHT);
	}
	
	public void init()
	{
		resize(USERPANEL_WIDTH, 300);
		
		userPanel = new Panel();
		userPanel.setSize(USERPANEL_WIDTH, USERPANEL_HEIGHT);
		add(userPanel);
		
		addComponentListener(this);
		
		userPanel.add(new Label("Operation:"));
		
		choiceOperation = new Choice();
		choiceOperation.add("Insert");
		choiceOperation.add("Remove");
		userPanel.add(choiceOperation);
		
		userPanel.add(new Label("Value:"));
		
		textValue = new TextField();
		userPanel.add(textValue);
		
		Button buttonGo = new Button("Go");
		userPanel.add(buttonGo);
		buttonGo.addActionListener(this);
				
		treeCanvas = new BinaryTreeCanvas();
		add(treeCanvas);
		
		userPanel.setBounds(0, 0, getWidth(), USERPANEL_HEIGHT);
		treeCanvas.setBounds(0, USERPANEL_HEIGHT, getWidth(), getHeight() - USERPANEL_HEIGHT);		
	}
}
